Index: uspace/lib/gfxfont/doc/doxygroups.h
===================================================================
--- uspace/lib/gfxfont/doc/doxygroups.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/doc/doxygroups.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,3 @@
+/** @addtogroup libgfxfont libgfxfont
+ * @ingroup libs
+ */
Index: uspace/lib/gfxfont/include/gfx/font.h
===================================================================
--- uspace/lib/gfxfont/include/gfx/font.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/include/gfx/font.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Font
+ */
+
+#ifndef _GFX_FONT_H
+#define _GFX_FONT_H
+
+#include <errno.h>
+#include <stddef.h>
+#include <types/gfx/context.h>
+#include <types/gfx/font.h>
+#include <types/gfx/glyph.h>
+
+extern void gfx_font_metrics_init(gfx_font_metrics_t *);
+extern errno_t gfx_font_create(gfx_context_t *, gfx_font_metrics_t *,
+    gfx_font_t **);
+extern void gfx_font_destroy(gfx_font_t *);
+extern void gfx_font_get_metrics(gfx_font_t *, gfx_font_metrics_t *);
+extern errno_t gfx_font_set_metrics(gfx_font_t *, gfx_font_metrics_t *);
+extern gfx_glyph_t *gfx_font_first_glyph(gfx_font_t *);
+extern gfx_glyph_t *gfx_font_next_glyph(gfx_glyph_t *);
+extern int gfx_font_search_glyph(gfx_font_t *, const char *, gfx_glyph_t **,
+    size_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gfxfont/include/gfx/glyph.h
===================================================================
--- uspace/lib/gfxfont/include/gfx/glyph.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/include/gfx/glyph.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Glyph
+ */
+
+#ifndef _GFX_GLYPH_H
+#define _GFX_GLYPH_H
+
+#include <errno.h>
+#include <types/gfx/font.h>
+#include <types/gfx/glyph.h>
+#include <types/gfx/glyph_bmp.h>
+
+extern void gfx_glyph_metrics_init(gfx_glyph_metrics_t *);
+extern errno_t gfx_glyph_create(gfx_font_t *, gfx_glyph_metrics_t *,
+    gfx_glyph_t **);
+extern void gfx_glyph_destroy(gfx_glyph_t *);
+extern void gfx_glyph_get_metrics(gfx_glyph_t *, gfx_glyph_metrics_t *);
+extern errno_t gfx_glyph_set_metrics(gfx_glyph_t *, gfx_glyph_metrics_t *);
+extern errno_t gfx_glyph_set_pattern(gfx_glyph_t *, const char *);
+extern void gfx_glyph_clear_pattern(gfx_glyph_t *, const char *);
+extern errno_t gfx_glyph_open_bmp(gfx_glyph_t *, gfx_glyph_bmp_t **);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gfxfont/include/gfx/glyph_bmp.h
===================================================================
--- uspace/lib/gfxfont/include/gfx/glyph_bmp.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/include/gfx/glyph_bmp.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Glyph bitmap
+ */
+
+#ifndef _GFX_GLYPH_BMP_H
+#define _GFX_GLYPH_BMP_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <types/gfx/glyph_bmp.h>
+
+extern errno_t gfx_glyph_bmp_save(gfx_glyph_bmp_t *);
+extern void gfx_glyph_bmp_close(gfx_glyph_bmp_t *);
+extern int gfx_glyph_bmp_getpix(gfx_glyph_bmp_t *, gfx_coord_t, gfx_coord_t);
+extern errno_t gfx_glyph_bmp_setpix(gfx_glyph_bmp_t *, gfx_coord_t,
+    gfx_coord_t, int);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gfxfont/include/types/gfx/font.h
===================================================================
--- uspace/lib/gfxfont/include/types/gfx/font.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/include/types/gfx/font.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Font types
+ */
+
+#ifndef _TYPES_GFX_FONT_H
+#define _TYPES_GFX_FONT_H
+
+#include <types/gfx/coord.h>
+
+struct gfx_font;
+typedef struct gfx_font gfx_font_t;
+
+/** Font metrics */
+typedef struct {
+	/** Ascent */
+	gfx_coord_t acent;
+	/** Descent */
+	gfx_coord_t descent;
+	/** Leading */
+	gfx_coord_t leading;
+} gfx_font_metrics_t;
+
+/** Text metrics */
+typedef struct {
+	/** Bounding rectangle (not including oversize elements) */
+	gfx_rect_t bounds;
+} gfx_text_metrics_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gfxfont/include/types/gfx/glyph.h
===================================================================
--- uspace/lib/gfxfont/include/types/gfx/glyph.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/include/types/gfx/glyph.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,53 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Glyph types
+ */
+
+#ifndef _TYPES_GFX_GLYPH_H
+#define _TYPES_GFX_GLYPH_H
+
+#include <types/gfx/coord.h>
+
+struct gfx_glyph;
+typedef struct gfx_glyph gfx_glyph_t;
+
+/** Glyph metrics */
+typedef struct {
+	/** Advance */
+	gfx_coord_t advance;
+} gfx_glyph_metrics_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gfxfont/include/types/gfx/glyph_bmp.h
===================================================================
--- uspace/lib/gfxfont/include/types/gfx/glyph_bmp.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/include/types/gfx/glyph_bmp.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Glyph types
+ */
+
+#ifndef _TYPES_GFX_GLYPH_BMP_H
+#define _TYPES_GFX_GLYPH_BMP_H
+
+struct gfx_glyph_bmp;
+typedef struct gfx_glyph_bmp gfx_glyph_bmp_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gfxfont/meson.build
===================================================================
--- uspace/lib/gfxfont/meson.build	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/meson.build	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,41 @@
+#
+# Copyright (c) 2020 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+deps = [ 'gfx' ]
+src = files(
+	'src/font.c',
+	'src/glyph.c',
+	'src/glyph_bmp.c',
+)
+
+test_src = files(
+	'test/font.c',
+	'test/glyph.c',
+	'test/glyph_bmp.c',
+	'test/main.c',
+)
Index: uspace/lib/gfxfont/private/font.h
===================================================================
--- uspace/lib/gfxfont/private/font.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/private/font.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Font structure
+ *
+ */
+
+#ifndef _GFX_PRIVATE_FONT_H
+#define _GFX_PRIVATE_FONT_H
+
+#include <types/gfx/context.h>
+#include <types/gfx/font.h>
+
+/** Font
+ *
+ * This is private to libgfxfont.
+ */
+struct gfx_font {
+	/** Graphics context of the font */
+	gfx_context_t *gc;
+	/** Font metrics */
+	gfx_font_metrics_t metrics;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gfxfont/private/glyph.h
===================================================================
--- uspace/lib/gfxfont/private/glyph.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/private/glyph.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Glyph structure
+ *
+ */
+
+#ifndef _GFX_PRIVATE_GLYPH_H
+#define _GFX_PRIVATE_GLYPH_H
+
+#include <adt/list.h>
+#include <types/gfx/glyph.h>
+
+/** Glyph
+ *
+ * This is private to libgfxfont.
+ */
+struct gfx_glyph {
+	/** Containing font */
+	struct gfx_font *font;
+	/** Link to list of glyphs in the font */
+	list_t lglyphs;
+	/** Glyph metrics */
+	gfx_glyph_metrics_t metrics;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gfxfont/private/glyph_bmp.h
===================================================================
--- uspace/lib/gfxfont/private/glyph_bmp.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/private/glyph_bmp.h	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,56 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Glyph structure
+ *
+ */
+
+#ifndef _GFX_PRIVATE_GLYPH_BMP_H
+#define _GFX_PRIVATE_GLYPH_BMP_H
+
+/** Glyph bitmap
+ *
+ * Glyph bitmap open for editing. This is used to edit glyph bitmap.
+ * Updating the entire font bitmap whenever the glyph is resized could
+ * be costly. This allows to postpone the update until we are done editing.
+ *
+ * This is private to libgfxfont.
+ */
+struct gfx_glyph_bmp {
+	/** Containing glyph */
+	struct gfx_glyph *glyph;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gfxfont/src/font.c
===================================================================
--- uspace/lib/gfxfont/src/font.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/src/font.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,155 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Font
+ */
+
+#include <assert.h>
+#include <errno.h>
+#include <gfx/font.h>
+#include <mem.h>
+#include <stdlib.h>
+#include "../private/font.h"
+
+/** Initialize font metrics structure.
+ *
+ * Font metrics structure must always be initialized using this function
+ * first.
+ *
+ * @param metrics Font metrics structure
+ */
+void gfx_font_metrics_init(gfx_font_metrics_t *metrics)
+{
+	memset(metrics, 0, sizeof(gfx_font_metrics_t));
+}
+
+/** Create font in graphics context.
+ *
+ * @param gc Graphic context
+ * @param metrics Font metrics
+ * @param rfont Place to store pointer to new font
+ *
+ * @return EOK on success, EINVAL if parameters are invald,
+ *         ENOMEM if insufficient resources, EIO if graphic device connection
+ *         was lost
+ */
+errno_t gfx_font_create(gfx_context_t *gc, gfx_font_metrics_t *metrics,
+    gfx_font_t **rfont)
+{
+	gfx_font_t *font;
+	errno_t rc;
+
+	font = calloc(1, sizeof(gfx_font_t));
+	if (font == NULL)
+		return ENOMEM;
+
+	font->gc = gc;
+
+	rc = gfx_font_set_metrics(font, metrics);
+	if (rc != EOK) {
+		assert(rc == EINVAL);
+		free(font);
+		return rc;
+	}
+
+	font->metrics = *metrics;
+	*rfont = font;
+	return EOK;
+}
+
+/** Destroy font.
+ *
+ * @param font Font
+ */
+void gfx_font_destroy(gfx_font_t *font)
+{
+	free(font);
+}
+
+/** Get font metrics.
+ *
+ * @param font Font
+ * @param metrics Place to store metrics
+ */
+void gfx_font_get_metrics(gfx_font_t *font, gfx_font_metrics_t *metrics)
+{
+	*metrics = font->metrics;
+}
+
+/** Set font metrics.
+ *
+ * @param font Font
+ * @param metrics Place to store metrics
+ * @return EOK on success, EINVAL if supplied metrics are invalid
+ */
+errno_t gfx_font_set_metrics(gfx_font_t *font, gfx_font_metrics_t *metrics)
+{
+	font->metrics = *metrics;
+	return EOK;
+}
+
+/** Get first glyph in font.
+ *
+ * @param font Font
+ * @return First glyph or @c NULL if there are none
+ */
+gfx_glyph_t *gfx_font_first_glyph(gfx_font_t *font)
+{
+	return NULL;
+}
+
+/** Get next glyph in font.
+ *
+ * @param cur Current glyph
+ * @return Next glyph in font or @c NULL if @a cur was the last one
+ */
+gfx_glyph_t *gfx_font_next_glyph(gfx_glyph_t *cur)
+{
+	return NULL;
+}
+
+/** Search for glyph that should be set for the beginning of a string.
+ *
+ * @param font Font
+ * @param str String whose beginning we would like to set
+ * @param rglyph Place to store glyph that should be set
+ * @param rsize Place to store number of bytes to advance in the string
+ * @return EOK on success, ENOENT if no matching glyph was found
+ */
+int gfx_font_search_glyph(gfx_font_t *font, const char *str,
+    gfx_glyph_t **rglyph, size_t *rsize)
+{
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/lib/gfxfont/src/glyph.c
===================================================================
--- uspace/lib/gfxfont/src/glyph.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/src/glyph.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,158 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Glyph
+ */
+
+#include <assert.h>
+#include <errno.h>
+#include <gfx/glyph.h>
+#include <mem.h>
+#include <stdlib.h>
+#include "../private/glyph.h"
+
+/** Initialize glyph metrics structure.
+ *
+ * Glyph metrics structure must always be initialized using this function
+ * first.
+ *
+ * @param metrics Glyph metrics structure
+ */
+void gfx_glyph_metrics_init(gfx_glyph_metrics_t *metrics)
+{
+	memset(metrics, 0, sizeof(gfx_glyph_metrics_t));
+}
+
+/** Create glyph.
+ *
+ * @param font Containing font
+ * @param metrics Glyph metrics
+ * @param rglyph Place to store pointer to new glyph
+ *
+ * @return EOK on success, EINVAL if parameters are invald,
+ *         ENOMEM if insufficient resources, EIO if graphic device connection
+ *         was lost
+ */
+errno_t gfx_glyph_create(gfx_font_t *font, gfx_glyph_metrics_t *metrics,
+    gfx_glyph_t **rglyph)
+{
+	gfx_glyph_t *glyph;
+	errno_t rc;
+
+	glyph = calloc(1, sizeof(gfx_glyph_t));
+	if (glyph == NULL)
+		return ENOMEM;
+
+	glyph->font = font;
+
+	rc = gfx_glyph_set_metrics(glyph, metrics);
+	if (rc != EOK) {
+		assert(rc == EINVAL);
+		free(glyph);
+		return rc;
+	}
+
+	glyph->metrics = *metrics;
+	*rglyph = glyph;
+	return EOK;
+}
+
+/** Destroy glyph.
+ *
+ * @param glyph Glyph
+ */
+void gfx_glyph_destroy(gfx_glyph_t *glyph)
+{
+	free(glyph);
+}
+
+/** Get glyph metrics.
+ *
+ * @param glyph Glyph
+ * @param metrics Place to store metrics
+ */
+void gfx_glyph_get_metrics(gfx_glyph_t *glyph, gfx_glyph_metrics_t *metrics)
+{
+	*metrics = glyph->metrics;
+}
+
+/** Set glyph metrics.
+ *
+ * @param glyph Glyph
+ * @param metrics Place to store metrics
+ * @return EOK on success, EINVAL if supplied metrics are invalid
+ */
+errno_t gfx_glyph_set_metrics(gfx_glyph_t *glyph, gfx_glyph_metrics_t *metrics)
+{
+	glyph->metrics = *metrics;
+	return EOK;
+}
+
+/** Set a pattern that the glyph will match.
+ *
+ * A glyph can match any number of patterns. Setting the same pattern
+ * again has no effect. The pattern is a simple (sub)string. Matching
+ * is done using maximum munch rule.
+ *
+ * @param glyph Glyph
+ * @param pattern Pattern
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t gfx_glyph_set_pattern(gfx_glyph_t *glyph, const char *pattern)
+{
+	return EOK;
+}
+
+/** Clear a matching pattern from a glyph.
+ *
+ * Clearing a pattern that is not set has no effect.
+ *
+ * @param Glyph
+ * @param pattern Pattern
+ */
+void gfx_glyph_clear_pattern(gfx_glyph_t *glyph, const char *pattern)
+{
+}
+
+/** Open glyph bitmap for editing.
+ *
+ * @param glyph Glyph
+ * @param rbmp Place to store glyph bitmap
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t gfx_glyph_open_bmp(gfx_glyph_t *glyph, gfx_glyph_bmp_t **rbmp)
+{
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/lib/gfxfont/src/glyph_bmp.c
===================================================================
--- uspace/lib/gfxfont/src/glyph_bmp.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/src/glyph_bmp.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,86 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libgfxfont
+ * @{
+ */
+/**
+ * @file Glyph bitmap
+ */
+
+#include <errno.h>
+#include <gfx/glyph_bmp.h>
+#include <stdlib.h>
+#include "../private/glyph_bmp.h"
+
+/** Save glyph bitmap.
+ *
+ * @param bmp Glyph bitmap
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t gfx_glyph_bmp_save(gfx_glyph_bmp_t *bmp)
+{
+	return EOK;
+}
+
+/** Close glyph bitmap.
+ *
+ * @param bmp Glyph bitmap
+ */
+void gfx_glyph_bmp_close(gfx_glyph_bmp_t *bmp)
+{
+}
+
+/** Get pixel from glyph bitmap.
+ *
+ * @param bmp Glyph bitmap
+ * @param x X-coordinate
+ * @param y Y-coordinate
+ * @return Pixel value
+ */
+int gfx_glyph_bmp_getpix(gfx_glyph_bmp_t *bmp, gfx_coord_t x, gfx_coord_t y)
+{
+	return 0;
+}
+
+/** Set pixel in glyph bitmap.
+ *
+ * @param bmp Glyph bitmap
+ * @param x X-coordinate
+ * @param y Y-coordinate
+ *
+ * @reutrn EOK on success, ENOMEM if out of memory
+ */
+errno_t gfx_glyph_bmp_setpix(gfx_glyph_bmp_t *bmp, gfx_coord_t x,
+    gfx_coord_t y, int value)
+{
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/lib/gfxfont/test/font.c
===================================================================
--- uspace/lib/gfxfont/test/font.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/test/font.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,40 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <gfx/font.h>
+#include <pcut/pcut.h>
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(font);
+
+PCUT_TEST(dummy)
+{
+}
+
+PCUT_EXPORT(font);
Index: uspace/lib/gfxfont/test/glyph.c
===================================================================
--- uspace/lib/gfxfont/test/glyph.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/test/glyph.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,40 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <gfx/glyph.h>
+#include <pcut/pcut.h>
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(glyph);
+
+PCUT_TEST(dummy)
+{
+}
+
+PCUT_EXPORT(glyph);
Index: uspace/lib/gfxfont/test/glyph_bmp.c
===================================================================
--- uspace/lib/gfxfont/test/glyph_bmp.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/test/glyph_bmp.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,40 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <gfx/glyph.h>
+#include <pcut/pcut.h>
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(glyph_bmp);
+
+PCUT_TEST(dummy)
+{
+}
+
+PCUT_EXPORT(glyph_bmp);
Index: uspace/lib/gfxfont/test/main.c
===================================================================
--- uspace/lib/gfxfont/test/main.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
+++ uspace/lib/gfxfont/test/main.c	(revision ee2f0bebcbd1e2ecc6efffb33da7df3c9c6404f5)
@@ -0,0 +1,37 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <pcut/pcut.h>
+
+PCUT_INIT;
+
+PCUT_IMPORT(font);
+PCUT_IMPORT(glyph);
+PCUT_IMPORT(glyph_bmp);
+
+PCUT_MAIN();
